/*  P2-5fanrecon1.c  (Program 2-5)  */

/* --- vO̐ ---
@Ɍo킪zuꂽt@r[ef[^璼ڍč\vOD

́F
  1Dt@r[ef[^̃t@C
  2Def[^̓a̐io̐j
  3Def[^̊px̐iej
  4D]S܂ł̒ifj
  5Dẻ]i1: , -1: Ej
  6Do͂č\摜f[^̃t@C
  7D摜f[^̕@ỉfj
  8D摜f[^̍ic̉fj

óF
  t@r[ef[^č\摜f[^̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n2-1.prj"; /* input file name */
int     g_px = 256;            /* number of matrix (x) */
int     g_pa = 256;            /* number of matrix (y) */
int     g_d  = 512;            /* source origin length (pixel) */
int     g_rd = 1;              /* rotate direction (1: counter clockwise, -1: clockwise) */
char    g_f2[50] = "n2-5.img"; /* output file name */
int     g_nx = 256;            /* number of matrix (x) */
int     g_ny = 256;            /* number of matrix (y) */
float   *g_prj;                /* fan-beam projection data */
float   *g_img;                /* image data */

// ͗pRg
char *menu[] = {
	"P2-5 FAN-beam reconstrucion for circular detector",
	"Input projection file name <float> ",
	"Number of bins                ",
	"Number of projections         ",
	"Source origin length  (pixel) ",
	"Rotate direction (1: counter clockwise, -1: clockwise) ",
	"Output image file name     <float> ",
	"Number of image width         ",
	"Number of image height        ",
};

// vg^Cv錾
void read_data(char *, float *, int);
void write_data(char *, float *, int);
void projection_correction1(float *, int, int, int);
void ram_lak_filtering1(float *, int, int, int);
void weighted_backprojection1(float *, int, int, float *, int, int, int, int);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_d );
	if(*fgets(dat, 256, stdin) != '\n')  g_d  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_rd );
	if(*fgets(dat, 256, stdin) != '\n')  g_rd = atoi(dat);
	fprintf( stdout, " %s [%s] :", menu[i++], g_f2 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f2, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_nx );
	if(*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_ny );
	if(*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
}

void main(void)
{
	// vOŎgpϐ̓
	getparameter();

	// eƉ摜f[^̈̃𓮓IɊm
	g_prj = (float *)malloc((unsigned long)g_px*g_pa*sizeof(float));
	g_img = (float *)malloc((unsigned long)g_px*g_pa*sizeof(float));

	printf(" *** Read Image data   ***\n");
	// t@r[ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px*g_pa);

	printf(" *** Projection Correction ***\n");
	// y菇1zvWFNV̕␳
	projection_correction1(g_prj, g_px, g_pa, g_d);

	printf(" *** Ram-Lak Filtering ***\n");
	// y菇2zRam-Lak tB^O
	ram_lak_filtering1(g_prj, g_px, g_pa, g_d);

	printf(" *** Weighted Back-Projection ***\n");
	// y菇3zd݂Âte
	weighted_backprojection1(g_img, g_nx, g_ny, g_prj, g_px, g_pa, g_d, g_rd);

	printf(" *** Write Image data   ***\n");
	// č\摜̏
	write_data(g_f2, g_img, g_nx*g_ny);

	// IɊmۂ̉
	free(g_prj);
	free(g_img);
}

// f[^̈̓́ifloatf[^j
void read_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and read data */
	if((fp = fopen(fi, "rb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(dat, sizeof(float), size, fp);
	fclose(fp);
}

// f[^̈̏óifloatf[^j
void write_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(dat, sizeof(float), size, fp);
	fclose(fp);
}

void projection_correction1(float *prj, int px, int pa, int d)
// y菇1zt@f[^̕␳
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// double  d;    X]S܂ł̋ifj
{
	int     i, j;
	double  af, da, dca;

	// t@p̃TvOԊǔvZ
	da = atan2((double)px/2, (double)d)/(px/2);

	for(j = 0 ; j < px ; j++)
	{
		af = (j-px/2)*da; // ̎Zo
		dca = d*cos(af);  // DcošvZ
		for(i = 0 ; i < pa ; i++)
		{
			prj[i*px+j] *= (float)dca;
		}
	}
}

void ram_lak_filtering1(float *prj, int px, int pa, int d)
// y菇2zdϕɂRam-LaktB^␳
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// double  d;    X]S܂ł̋ifj
{
	int     i, j, k;
	double  h, da, am, sa;
	double  *pab;

	pab = (double *)malloc((unsigned long)g_px*sizeof(double));

	// t@p̃TvOԊǔvZ
	da = atan2((double)px/2, (double)d)/(px/2);

	for(i = 0 ; i < pa ; i++)
	{
		for(j = 0 ; j < px ; j++)
		{
			pab[j] = 0;
			for(k = 0 ; k < px ; k++)
			{
				am = (j-k)*da; // m̎Zo
				sa = sin(am);  // sin(m)̌vZ

				// Ramachandran-LakshiminarayanantB^*(/sin)2
				if(j-k == 0)
					h = 1/(4*da*da);
				else if(abs(j-k)%2 == 0)
					h = 0;
				else
					h = -1/(PI*PI*sa*sa);

				// tB^̏dipĝPI*da{j
				pab[j] += prj[i*px+k]*h*PI*da;
			}
		}
		for(j = 0 ; j < px ; j++)
			prj[i*px+j] = (float)pab[j];
	}

	free(pab);
}

void weighted_backprojection1(float *img, int nx, int ny, float *prj, int px, int pa, int d, int rd)
// y菇3zd݂Âte
// float   *img; č\摜f[^
// int     nx;   摜f[^̕
// int     ny;   摜f[^̍
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// double  d;    X]S܂ł̋ifj
// int     rd;   ]i1:[counter clockwise], -1:E[clockwise]j
{
	int     i, j, k;
	double  x, y, af, bf, t, phi, L1, da, co, si;
	// `ԗp̕ϐ
	int     ia0, ia1;
	double  da0, da1;

	// t@p̃TvOԊǔvZ
	da = atan2((double)px/2, (double)d)/(px/2);

	// 摜̈̏
	for(i = 0 ; i < nx*ny ; i++)
		img[i] = (float)0;

	// te
	for(k = 0 ; k < pa ; k++)
	{
		bf = 2*PI*k/pa*rd;
		for(i = 0 ; i < ny ; i++)
		{
			y = ny/2 - i;
			for(j = 0 ; j < nx ; j++)
			{
				x = j - nx/2;
				t = sqrt(x*x+y*y);
				phi = atan2(y, x);
				co = cos(bf-phi);
				si = sin(bf-phi);
				L1 = sqrt((d+t*si)*(d+t*si)+(t*co)*(t*co));
				af = atan2(t*co, d+t*si); // '̒l
				af = af/da+px/2;

				// ̐`Ԃ̏
				ia0 = (int)floor(af);
				ia1 = ia0+1;
				if(ia0 < 0 || ia1 > px-1) continue;
				da0 = af-ia0;
				da1 = 1-da0;

				// `
				img[i*nx+j] += (float)
					((da0*prj[k*px+ia1]+da1*prj[k*px+ia0])/(L1*L1));
			}
		}
	}

	for(i = 0 ; i < nx*ny ; i++)
		img[i] /= pa;
}
