/*  P2-6fanrecon2.c  (Program 2-6)  */

/* --- vO̐ ---
@Ɍo킪zuꂽt@r[ef[^璼ڍč\vOD

́F
  1Dt@r[ef[^̃t@C
  2Def[^̓a̐io̐j
  3Def[^̊px̐iej
  4D]S܂ł̒ifj
  5Dẻ]i1: , -1: Ej
  6Do͂č\摜f[^̃t@C
  7D摜f[^̕@ỉfj
  8D摜f[^̍ic̉fj

óF
  t@r[ef[^č\摜f[^̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n2-2.prj"; /* input file name */
int     g_px = 256;            /* number of matrix (x) */
int     g_pa = 256;            /* number of matrix (y) */
int     g_d  = 512;            /* source origin length (pixel) */
int     g_rd = 1;              /* rotate direction (1: counter clockwise, -1: clockwise) */
char    g_f2[50] = "n2-6.img"; /* output file name */
int     g_nx = 256;            /* number of matrix (x) */
int     g_ny = 256;            /* number of matrix (y) */
float   *g_prj;                /* fan-beam projection data */
float   *g_img;                /* image data */

// ͗pRg
char *menu[] = {
	"P2-6 FAN-beam reconstrucion for linear detector",
	"Input projection file name <float> ",
	"Number of bins                ",
	"Number of projections         ",
	"Source origin length  (pixel) ",
	"Rotate direction (1: counter clockwise, -1: clockwise) ",
	"Output image file name     <float> ",
	"Number of image width         ",
	"Number of image height        ",
};

// vg^Cv錾
void read_data(char *, float *, int);
void write_data(char *, float *, int);
void projection_correction2(float *, int, int, int);
void ram_lak_filtering2(float *, int, int);
void weighted_backprojection2(float *, int, int, float *, int, int, int, int);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_d );
	if(*fgets(dat, 256, stdin) != '\n')  g_d  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_rd );
	if(*fgets(dat, 256, stdin) != '\n')  g_rd = atoi(dat);
	fprintf( stdout, " %s [%s] :", menu[i++], g_f2 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f2, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_nx );
	if(*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_ny );
	if(*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
}

void main(void)
{
	// vOŎgpϐ̓
	getparameter();

	// eƉ摜f[^̈̃𓮓IɊm
	g_prj = (float *)malloc((unsigned long)g_px*g_pa*sizeof(float));
	g_img = (float *)malloc((unsigned long)g_px*g_pa*sizeof(float));

	printf(" *** Read Image data   ***\n");
	// t@r[ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px*g_pa);

	printf(" *** Projection Correction ***\n");
	// y菇1zvWFNV̕␳
	projection_correction2(g_prj, g_px, g_pa, g_d);

	printf(" *** Ram-Lak Filtering ***\n");
	// y菇2zRam-Lak tB^O
	ram_lak_filtering2(g_prj, g_px, g_pa);

	printf(" *** Weighted Back-Projection ***\n");
	// y菇3zd݂Âte
	weighted_backprojection2(g_img, g_nx, g_ny, g_prj, g_px, g_pa, g_d, g_rd);

	printf(" *** Write Image data   ***\n");
	// č\摜̏
	write_data(g_f2, g_img, g_nx*g_ny);

	// IɊmۂ̉
	free(g_prj);
	free(g_img);
}

// f[^̈̓́ifloatf[^j
void read_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and read data */
	if((fp = fopen(fi, "rb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(dat, sizeof(float), size, fp);
	fclose(fp);
}

// f[^̈̏óifloatf[^j
void write_data(char *fi, float *dat, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL)
	{
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(dat, sizeof(float), size, fp);
	fclose(fp);
}

void projection_correction2(float *prj, int px, int pa, int d)
// y菇1zt@f[^̕␳
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// double  d;    X]S܂ł̋ifj
{
	int     i, j;
	double  xf, dx;

	for(j = 0 ; j < px ; j++)
	{
		xf = j-px/2;             // X̎Zo
		dx = d/sqrt(d*d+xf*xf);  // D/D*D+X*X̌vZ
		for(i = 0 ; i < pa ; i++)
		{
			prj[i*px+j] *= (float)dx;
		}
	}
}

void ram_lak_filtering2(float *prj, int px, int pa)
// y菇2zdϕɂRam-LaktB^␳
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
{
	int     i, j, k;
	double  h, ri;
	double  *pxb;

	pxb = (double *)malloc((unsigned long)g_px*sizeof(double));

	for(i = 0 ; i < pa ; i++)
	{
		for(j = 0 ; j < px ; j++)
		{
			pxb[j] = 0;
			for(k = 0 ; k < px ; k++)
			{
				ri = j-k;   // ri̎Zo

				// Ramachandran-LakshiminarayanantB^
				if(j-k == 0)
					h = 1.0/4.0;
				else if(abs(j-k)%2 == 0)
					h = 0;
				else
					h = -1/(PI*PI*ri*ri);

				// tB^̏dipĝPI{j
				pxb[j] += prj[i*px+k]*h*PI;
			}
		}
		for(j = 0 ; j < px ; j++)
			prj[i*px+j] = (float)pxb[j];
	}

	free(pxb);
}

void weighted_backprojection2(float *img, int nx, int ny, float *prj, int px, int pa, int d, int rd)
// y菇3zd݂Âte
// float   *img; č\摜f[^
// int     nx;   摜f[^̕
// int     ny;   摜f[^̍
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^̓a̐
// int     pa;   ef[^̊px̐i360xj
// double  d;    X]S܂ł̋ifj
// int     rd;   ]i1:[counter clockwise], -1:E[clockwise]j
{
	int     i, j, k;
	double  x, y, xf, bf, t, phi, L2;
	// `ԗp̕ϐ
	int     ix0, ix1;
	double  dx0, dx1;

	// 摜̈̏
	for(i = 0 ; i < nx*ny ; i++)
		img[i] = (float)0;

	// te
	for(k = 0 ; k < pa ; k++)
	{
		bf = 2*PI*k/pa*rd;
		for(i = 0 ; i < ny ; i++)
		{
			y = ny/2 - i;
			for(j = 0 ; j < nx ; j++)
			{
				x = j - nx/2;
				t = sqrt(x*x+y*y);
				phi = atan2(y, x);
				L2 = (t*sin(bf-phi)+d)/d;
				xf = t*cos(bf-phi)/L2;    // X'̒l
				xf += px/2;

				// X̐`Ԃ̏
				ix0 = (int)floor(xf);
				ix1 = ix0+1;
				if(ix0 < 0 || ix1 > px-1) continue;
				dx0 = xf-ix0;
				dx1 = 1-dx0;

				// `
				img[i*nx+j] += (float)
					((dx0*prj[k*px+ix1]+dx1*prj[k*px+ix0])/(L2*L2));
			}
		}
	}

	for(i = 0 ; i < nx*ny ; i++)
		img[i] /= pa;
}
