/*  P5-2helicalrecon.c  (Program 5-2)  */

/*
  --- vO̐ ---
@wJR[r[ef[^Feldkamp𗘗p摜č\@ōč\vOD

́F
  1DR[r[ef[^̃t@C
  2Def[^X̐io̐j
  3Def[^Z̐io̐j
  4Def[^̊px̐iej
  5Def[^̑Spx@@@@ ixj
  6Def[^zJnʒuZ0izj
  7Def[^z1dizj
  8D]S܂ł̒ifj
  9Dẻ]i1: , -1: Ej
 10Do͂č\摜f[^̃t@C
 11D摜f[^̕@@ix̉fj
 12D摜f[^̉siỷfj
 13D摜f[^̍@iz̉fj

óF
  ȉ~̃f[^쐬摜̃t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char     g_f1[50] = "n5-1.prj"; /* input file name */
int      g_px = 256;            /* number of matrix (X) */
int      g_pz = 256;            /* number of matrix (Z) */
int      g_pa = 1024;           /* number of projection */
int      g_pd = 1440;           /* total-angle degree */
int      g_zs = -256;           /* z-start point */
int      g_zd = 128;            /* z-width of one cycle */
int      g_d  = 512;            /* source origin length */
int      g_rd = 1;              /* rotate direction (1: counter clockwise, -1: clockwise) */
char     g_f2[50] = "n5-2.img"; /* output file name */
int      g_nx = 256;            /* number of matrix (x) */
int      g_ny = 256;            /* number of matrix (y) */
int      g_nz = 256;            /* number of matrix (z) */
float   *g_prj;                 /* fan-beam projection data */
float   *g_img;                 /* image data */

// ͗pRg
char *menu[] = {
	"P5-2 helical reconstrucion for helical-beam projection",
	"Input projection file name <float> ",
	"Number of bins (X)             ",
	"Number of bins (Z)             ",
	"Number of projections          ",
	"Number of total-angle (deg)    ",
	"Number of z-start point        ",
	"Number of z-width of one cycle ",
	"Source origin length  (pixel)  ",
	"Rotate direction (1: counter clockwise, -1: clockwise) ",
	"Output image file name     <float> ",
	"Number of image x-width        ",
	"Number of image y-width        ",
	"Number of image z-width        ",
	};

// vg^Cv錾
void read_data(char *, float *, int);
void write_data(char *, float *, int);
void projection_correction3(float *, int, int, int, int);
void ram_lak_filtering3(float *, int, int, int);
void weighted_backprojection4(float *, int, int, int, float *, int, int, int, int, int, int, int, int);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_px );
	if(*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pz );
	if(*fgets(dat, 256, stdin) != '\n')  g_pz = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pa );
	if(*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_pd );
	if(*fgets(dat, 256, stdin) != '\n')  g_pd = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_zs );
	if(*fgets(dat, 256, stdin) != '\n')  g_zs = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_zd );
	if(*fgets(dat, 256, stdin) != '\n')  g_zd = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_d );
	if(*fgets(dat, 256, stdin) != '\n')  g_d  = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_rd );
	if(*fgets(dat, 256, stdin) != '\n')  g_rd = atoi(dat);
	fprintf( stdout, " %s [%s] :", menu[i++], g_f2 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f2, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_nx );
	if(*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_ny );
	if(*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_nz );
	if(*fgets(dat, 256, stdin) != '\n')  g_nz = atoi(dat);
}

void main(void)
{
	// vOŎgpϐ̓
	getparameter();

	// f[^̈̃𓮓IɊm
	g_prj = (float *)malloc((unsigned long)g_px*g_pz*g_pa*sizeof(float));
	g_img = (float *)malloc((unsigned long)g_nx*g_ny*g_nz*sizeof(float));

	printf(" *** Read Image data   ***\n");
	// R[r[ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px*g_pz*g_pa);

	printf(" *** Cone-Beam Reconstruction ***\n");
	// y菇1zvWFNV̕␳
	printf("  -- times D/sqrt(D^2+X^2+Z^2) --\n");
	projection_correction3(g_prj, g_px, g_pz, g_pa, g_d);
	write_data("n5-2a.prj", g_prj, g_px*g_pz*g_pa);

	// y菇2zRam-Lak tB^O
	printf("  -- convolution h(X) --\n");
	ram_lak_filtering3(g_prj, g_px, g_pz, g_pa);
	write_data("n5-2b.prj", g_prj, g_px*g_pz*g_pa);

	// y菇3zd݂Âte
	printf("  -- weighted back-projection --\n");
	weighted_backprojection4(g_img, g_nx, g_ny, g_nz, g_prj, g_px, g_pz, g_pa, g_pd, g_zs, g_zd, g_d, g_rd);

	printf(" *** Write Image data   ***\n");
	// č\摜̏
	write_data(g_f2, g_img, g_nx*g_ny*g_nz);

	// IɊmۂ̉
	free(g_prj);
	free(g_img);
}

void read_data(char *fi, float *prj, int size)
{
	FILE   *fp;
	/* open file and read data */
	if((fp = fopen(fi, "rb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(prj, sizeof(float), size, fp);
	fclose(fp);
}

void write_data(char *fi, float *prj, int size)
{
	FILE   *fp;
	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(prj, sizeof(float), size, fp);
	fclose(fp);
}

void projection_correction3(float *prj, int px, int pz, int pa, int d)
// y菇1zt@f[^̕␳
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^X̐
// int     pz;   ef[^Z̐
// int     pa;   ef[^̊px̐i360xj
// double  d;    X]S܂ł̋ifj
{
	int     i, j, k;
	double  x, z;

	for(i = 0 ; i < pa ; i++)
	{
		for(j = 0 ; j < pz ; j++)
		{
			z = pz/2-j;
			for(k = 0 ; k < px ; k++)
			{
				x = k-px/2;
				// ef[^D/(D^2+X^2+Z^2)|
				prj[i*px*pz+j*px+k] *= (float)(d/sqrt(d*d+x*x+z*z));
			}
		}
	}
}

void ram_lak_filtering3(float *prj, int px, int pz, int pa)
// y菇2zdϕɂRam-LaktB^␳
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^X̐
// int     pz;   ef[^Z̐
// int     pa;   ef[^̊px̐i360xj
{
	int     i, j, k, kk;
	double  h, si;
	double  *pxb;

	pxb = (double *)malloc((unsigned long)px*sizeof(double));

	for(i = 0 ; i < pa ; i++)
	{
		for(j = 0 ; j < pz ; j++)
		{
			for(k = 0 ; k < px ; k++)
			{
				pxb[k] = 0;
				for(kk = 0 ; kk < px ; kk++)
				{
					si = k-kk;   // si̎Zo

					// Ramachandran-LakshiminarayanantB^
					if(k-kk == 0)
						h = 1.0/4.0;
					else if(abs(k-kk)%2 == 0)
						h = 0;
					else
						h = -1/(PI*PI*si*si);

					// tB^̏dipĝPI{j
					pxb[k] += prj[i*pz*px+j*px+kk]*h*PI;
				}
			}
			for(k = 0 ; k < px ; k++)
				prj[i*pz*px+j*px+k] = (float)pxb[k];
		}
	}

	free(pxb);
}

void weighted_backprojection4(float *img, int nx, int ny, int nz, float *prj, int px, int pz, int pa, int pd, int zs, int zd, int d, int rd)
// y菇3zd݂Âte
// float   *img; č\摜f[^
// int     nx;   摜f[^̕
// int     ny;   摜f[^̉s
// int     nz;   摜f[^̍
// float   *prj; t@r[̓ef[^ 
// int     px;   ef[^X̐
// int     pz;   ef[^Z̐
// int     pa;   ef[^̊px̐
// int     pd;   ȇSpxixj
// int     zs;   z̊Jnʒu
// int     zd;   z̕
// int     d;    X]S܂ł̋ifPʁj
// int     rd;   ]i1:[counter clockwise], -1:E[clockwise]j
{
	int    i, j, k, ib;
	double x, y, z, b, xx, zz, va, b0, t;
	double ri, rj, rk;
	// `ԗp̕ϐ
	int    ix0, ix1, iz0, iz1, ib0, ib1;
	double dx0, dx1, dz0, dz1, db0, db1;
	// 1e̊px̕ωij
	double db = PI*pd/180.0/pa*rd;

	for(i = 0 ; i < nx*ny*nz ; i++)
		img[i] = (float)0;

	for(i = 0 ; i < nz ; i++) {
		fprintf(stderr, "\r -- [%3d/%3d]", i, nz);
		z = nz/2-i;
		b0 = 2*PI/zd*(nz/2-i-zs);
		for(j = 0 ; j < ny ; j++) {
			y = ny/2-j;
			for(k = 0 ; k < nx ; k++) {
				x = k-nx/2;
				for(ib = 0 ; ib < pa*360/pd ; ib++) {
					b = b0-PI*rd+ib*db; // px̐ϕ͈́i0}΁j
					ri =  x*cos(b)+y*sin(b);
					rj = -x*sin(b)+y*cos(b);
					rk = z;
					xx = d*ri/(d-rj);
					zz = d*(rk-(zd/(2*PI)*b+zs))/(d-rj); // wJXL̕ύX_
					xx = xx+px/2;
					zz = pz/2-zz;

					// X̐`Ԃ̏
					ix0 = (int)floor(xx);
					ix1 = ix0+1;
					if(ix0 < 0 || ix1 > px-1) continue;
					dx0 = xx-ix0;
					dx1 = 1-dx0;

					// Z̐`Ԃ̏
					iz0 = (int)floor(zz);
					iz1 = iz0+1;
					if(iz0 < 0 || iz1 > pz-1) continue;
					dz0 = zz-iz0;
					dz1 = 1-dz0;

					// ̐`Ԃ̏
					t = b/db;
					ib0 = (int)floor(t);
					ib1 = ib0+1;
					if(ib0 < 0 || ib1 > pa-1) continue;
					db0 = t-ib0;
					db1 = 1-db0;

					// 3`
					va = db1*dz1*dx1*prj[ib0*px*pz+iz0*px+ix0]
					   + db1*dz1*dx0*prj[ib0*px*pz+iz0*px+ix1]
					   + db1*dz0*dx1*prj[ib0*px*pz+iz1*px+ix0]
					   + db1*dz0*dx0*prj[ib0*px*pz+iz1*px+ix1]
					   + db0*dz1*dx1*prj[ib1*px*pz+iz0*px+ix0]
					   + db0*dz1*dx0*prj[ib1*px*pz+iz0*px+ix1]
					   + db0*dz0*dx1*prj[ib1*px*pz+iz1*px+ix0]
					   + db0*dz0*dx0*prj[ib1*px*pz+iz1*px+ix1];

					// dݕtte
					img[i*ny*nx+j*nx+k] += (float)(d*d/((d-rj)*(d-rj))*va);
				}
			}
		}
	}
		fprintf(stderr, "\r -- [%3d/%3d]\n", i, nz);

	for(i = 0 ; i < nx*ny*nz ; i++)
		img[i] /= pa;

}
