/*  P6-1radonspace2d.c  (Program 6-1)  */

/*
  --- vO̐ ---
@2摜烉hԉ摜쐬vOD

́F
  1D͂2摜̃t@C
  2Do͂郉hԂ̃t@C
  3D摜f[^̕@@ix̉fj
  4D摜f[^̉siỷfj

óF
  2hԂ̉摜t@C

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// O[oϐ̐錾Əlݒ
char     g_f1[50] = "n0.img";   /* input file name */
char     g_f2[50] = "n6-1.img"; /* output file name */
int      g_nx = 256;            /* number of matrix (x) */
int      g_ny = 256;            /* number of matrix (y) */
float   *g_img;                 /* image data */
float   *g_imr;                 /* radon space image data */

// ͗pRg
char *menu[] = {
	"P6-1 Make radon space image from a 2-d image",
	"Input  image file name <float> ",
	"Output image file name <float> ",
	"Number of image x-width        ",
	"Number of image y-width        ",
	};

// vg^Cv錾
void read_data(char *, float *, int);
void write_data(char *, float *, int);
void radonspace2d(float *, float *, int, int);

// ϐ̓
void getparameter()
{
	int   i;
	char  dat[256];

	// ϐւ̒l̓
	i = 0;
	fprintf( stdout, "\n%s\n\n", menu[i++] );
	fprintf( stdout, " %s [%s] :", menu[i++], g_f1 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f1, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%s] :", menu[i++], g_f2 );
	if(*fgets(dat, 256, stdin) != '\n')  strncpy(g_f2, dat, strlen(dat)-1);
	fprintf( stdout, " %s [%d] :", menu[i++], g_nx );
	if(*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	fprintf( stdout, " %s [%d] :", menu[i++], g_ny );
	if(*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
}

void main(void)
{
	int  i;

	// vOŎgpϐ̓
	getparameter();

	// f[^̈̃𓮓IɊm
	g_img = (float *)malloc((unsigned long)g_nx*g_ny*sizeof(float));
	g_imr = (float *)malloc((unsigned long)g_nx*g_ny*sizeof(float));

	printf(" *** Read Image data   ***\n");
	// 摜f[^̓ǂݏo
	read_data(g_f1, g_img, g_nx*g_ny);

	// hԂ̍쐬
	printf("  -- Make radon space image --\n");
	for(i = 0 ; i < g_nx*g_ny ; i++)
		g_imr[i] = (float)0;
	radonspace2d(g_imr, g_img, g_nx, g_ny);

	printf(" *** Write Image data   ***\n");
	// hԉ摜̏
	write_data(g_f2, g_imr, g_nx*g_ny);

	// IɊmۂ̉
	free(g_img);
	free(g_imr);
}

void read_data(char *fi, float *prj, int size)
{
	FILE   *fp;
	/* open file and read data */
	if((fp = fopen(fi, "rb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(prj, sizeof(float), size, fp);
	fclose(fp);
}

void write_data(char *fi, float *prj, int size)
{
	FILE   *fp;
	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(prj, sizeof(float), size, fp);
	fclose(fp);
}

void radonspace2d(float *imr, float *img, int nx, int ny)
// 2摜2hԉ摜쐬
// float   *imr; 2hԉ摜f[^ 
// float   *img; 2摜f[^ 
// int     nx;   摜f[^x̐
// int     ny;   摜f[^y̐
{
	int     i, j, k, it;
	double  x, y, t, d0, sum;
	double  ax, ay, bx, by, xx, yy;
	// o`ԗpϐ
	int     ix0, ix1, iy0, iy1;
	double  dx0, dx1, dy0, dy1;

	for(i = 0 ; i < ny ; i++)
	{
		fprintf(stderr, "\r -- [%3d / %3d]", i, ny);
		y = ny/2-i;
		for(j = 0 ; j < nx ; j++)
		{
			x = j-nx/2;
			sum = 0;

			// 2hԉ摜̒ŜݕʌvZ
			if((d0 = sqrt(x*x+y*y)) == 0.0)
			{
			for(k = 0 ; k < nx*ny ; k++)
						sum += img[k];
			imr[i*nx+j] = (float)(sum/sqrt((nx*nx+ny*ny)/2.0));
					continue;
			}

			// ̃xNǧW
			ax = y/d0;
			ay = -x/d0;
			bx = x;
			by = y;

			// e͒TvOĂ̍v猈
			for(it = 0 ; it < nx ; it++)
			{
				t = nx/2-it; // TvOʒu

				// ̃xNg
				xx = ax*t+bx;
				yy = ay*t+by;

				// 摜Wւ̕ϊ
				xx = xx+nx/2;
				yy = ny/2-yy;

				// x`Ԃ̏
				ix0 = (int)floor(xx);
				ix1 = ix0+1;
				if(ix0 < 0 || ix1 > nx-1) continue;
				dx0 = ix0-xx;
				dx1 = 1-dx0;

				// y`Ԃ̏
				iy0 = (int)floor(yy);
				iy1 = iy0+1;
				if(iy0 < 0 || iy1 > ny-1) continue;
				dy0 = iy0-yy;
				dy1 = 1-dy0;

				// o`Ԃƍv̌vZ
				sum += dy0*dx0*img[iy1*nx+ix1]
						+  dy0*dx1*img[iy1*nx+ix0]
						+  dy1*dx0*img[iy0*nx+ix1]
						+  dy1*dx1*img[iy0*nx+ix0];
			}
			imr[i*nx+j] = (float)sum;
		}
	}
	fprintf(stderr, "\r -- [%3d / %3d]\n", i, ny);
}
